unit Thermometer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TTypeCharacterDegree=(cd20,cd10);    //ڐl\̌^ cd20:20xƁAcd10:10x
  TTypeUnitKind=(ukJapanese,ukSign);   //Pʂ̌^ ukJapanese:uxv ukSign:uv
  TTypeScaleInterval=(si01,si02,si05); //ڐ\̌^ si01:1x,si02:2x,si05:5x

  TThermometer = class(TCustomControl)
  private
    { Private 錾 }
    FWidthOutline: byte;                                                //E̕
    FWidthScale10Degree: byte;                                          //POx̐̕
    FWidthScale1Degree: byte;                                           //Px̐̕
    FWidthScale5Degree: byte;                                           //Tx̐̕
    FBarWidth: byte;                                                    //_̕
    FMargin: byte;                                                      //㉺E̗]
    ValueTextRect: TRect;                                               //ڐ̕`̈
    ValueText:string;                                                   //ڐ̕[x]
    FFontSizeDegree: byte;                                              //[x]̃tHgTCY
    FBoardColor: TColor;                                                //Ղ̐F
    FBarColor: TColor;                                                  //_̐F
    FTypeCharacterDegree: TTypeCharacterDegree;                         //ڐl\̌^
    FTypeScaleInterval:     TTypeScaleInterval;                         //ڐ\̌^
    FTypeUnitKind: TTypeUnitKind;                                       //Pʕ\̌^
    FValue: integer;                                                    //x[x]
    FValueMin:integer;                                                  //x̍ŏl
    FValueMax:integer;                                                  //x̍ől
    FOnChange: TNotifyEvent;
    function  HalfAdjust(x: Extended): Longint;                         //ľܓ
    procedure SetBarColor(const Value: TColor);                         //_̐Fݒ
    procedure SetBarWidth(const Value: byte);                           //_̕ݒ
    procedure SetBoardColor(const Value: TColor);                       //Ղ̐Fݒ
    procedure SetFontSizeDegree(const Value: byte);                     //Ղ̐l̃tHgTCYݒ
    procedure SetMargin(const Value: byte);                             //]̐ݒ
    procedure SetTypeCharacterDegree(const Value: TTypeCharacterDegree);//ڐl\̌^ݒ
    procedure SetTypeScaleInterval(const Value: TTypeScaleInterval);    //ڐ\̌^ݒ
    procedure SetTypeUnitKind(const Value: TTypeUnitKind);              //Pʕ\̌^ݒ
    procedure SetValue(const Value: integer);                           //xݒ
    procedure SetValueMin(const Value: integer);                        //Value̍őlݒ
    procedure SetValueMax(const Value: integer);                        //Value̍őlݒ
    procedure SetWidthOutline(const Value: byte);                       //O`̕ݒ
    procedure SetWidthScale1Degree(const Value: byte);                  //Px̐̕ݒ
    procedure SetWidthScale5Degree(const Value: byte);                  //Tx̐̕ݒ
    procedure SetWidthScale10Degree(const Value: byte);                 //10x̐̕ݒ
  protected
    { Protected 錾 }
    procedure Change; virtual; // OnChangeCxg̃CxgfBXpb`
    procedure Paint; override; //`
    procedure Resize;override; //Rg[̃TCYύX
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property Color;       // Ղ̔wii`j̐F
    property ParentColor; // eRg[F̌p
    property BarColor: TColor read FBarColor write SetBarColor default clRed;   // _̐F
    property BarWidth: byte read FBarWidth write SetBarWidth default 4;         // _̕
    property BoardColor: TColor read FBoardColor write SetBoardColor default clBtnFace;// Ձi`j̐F
    property FontSizeDegree: byte read FFontSizeDegree write SetFontSizeDegree default 4;// ڐ̐l̃tHgTCY
    property Margin: byte read FMargin write SetMargin default 5; //㉺E̗]̕
    property TypeCharacterDegree: TTypeCharacterDegree read FTypeCharacterDegree write SetTypeCharacterDegree default cd10;     //ڐl\̌^
    property TypeScaleInterval: TTypeScaleInterval read FTypeScaleInterval write SetTypeScaleInterval default si01;             //ڐ\̌^
    property TypeUnitKind: TTypeUnitKind read FTypeUnitKind write SetTypeUnitKind default ukJapanese;                           //Pʂ̌^
    property Value: integer read FValue write SetValue default 0;               // x
    property ValueMax: integer read FValueMax write SetValueMax default 200;    // _łɏオĂƂ̒lix̍őlj
    property ValueMin: integer read FValueMin write SetValueMin default -20;    // _łɉĂƂ̒lix̍ŏlj
    property WidthOutline: byte read FWidthOutline write SetWidthOutline default 1;                             //E̕
    property WidthScale1Degree: byte read FWidthScale1Degree write SetWidthScale1Degree default 1;              //  Px݂̍̐̕
    property WidthScale5Degree: byte read FWidthScale5Degree write SetWidthScale5Degree default 3;              //  Tx݂̍̐̕
    property WidthScale10Degree: byte read FWidthScale10Degree write SetWidthScale10Degree default 5;           //POx݂̍̐̕
    property ShowHint;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
  end;

procedure Register;

implementation
var UnitTopY,UnitBottomY,SphereTopY,SphereBottomY,SphereDiameter,BarTopY,BarBottomY: integer;

function TThermometer.HalfAdjust(x: Extended): Longint;
//ľܓ
begin
  if x >= 0 then Result := Trunc(x + 0.5)
  else Result := Trunc(x - 0.5);
end;

procedure Register;
begin
  RegisterComponents('Samples', [TThermometer]);
end;

constructor TThermometer.Create(AOwner: TComponent);
// RXgN^
begin
  inherited Create(AOwner);
//ʂ鏔̏
  Width:=150;
  Height:=500;
  FMargin:=5;
  FFontSizeDegree:= HalfAdjust(Height /160*4);

  FValueMin:=-20;
  FValueMax:=100;
  FValue:=0;
  FWidthOutline:=1;//HalfAdjust(FDiameter /160);
  FWidthScale1Degree:=1;//HalfAdjust(FDiameter /160);
  FWidthScale5Degree:=1;//HalfAdjust(FDiameter /160*2);
  FWidthScale10Degree:=1;//HalfAdjust(FDiameter /160*5);
  FBarWidth:=5;//HalfAdjust(FDiameter /160*5);
  FBarColor:= clRed;
  FBoardColor:= clBtnFace;
  FTypeCharacterDegree:= cd10;
  FTypeScaleInterval:= si01;
  FTypeUnitKind:= ukJapanese;

  // `ɂ̓`cL}邽߃_uobt@g
  DoubleBuffered := True;
end;

procedure TThermometer.Paint;//`
var i: integer;
begin
  //ʂ鏔猈܂l
  SphereDiameter:=15;
  UnitTopY:=FMargin+10;
  UnitBottomY:=UnitTopY+HalfAdjust(FFontSizeDegree*1.5);
  SphereBottomY:=Height-FMargin-10;
  SphereTopY:=   SphereBottomY- SphereDiameter;
  BarBottomY:=  SphereTopY-20;
  BarTopY:=UnitBottomY+20;

  //E
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Width:=FWidthOutline;
  canvas.Pen.Color:= clBlack;
  Canvas.Brush.Style := bsSolid;
  canvas.Brush.Color:= FBoardColor;
  if FWidthOutline<>0 then
    canvas.Rectangle(halfadjust(FMargin+ canvas.Pen.Width / 2), halfadjust(FMargin+ canvas.Pen.Width / 2), halfadjust(Width- FMargin- canvas.Pen.Width / 2), halfadjust(Height- FMargin- canvas.Pen.Width / 2));

  //KXǂ̊O`
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Color:= clBlack;
  canvas.Pen.Width:= 1;
  Canvas.Brush.color := FBarColor;
  canvas.Brush.Style:= bsClear;
  canvas.Ellipse(halfadjust(width/2   -SphereDiameter/2-2), halfadjust(SphereTopY-2), halfadjust(width/2   +SphereDiameter/2+2), halfadjust(SphereBottomY+2));

  Canvas.Moveto (HalfAdjust(Width/2-Barwidth/2),HalfAdjust((BarBottomY+ (FValue- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))));
  Canvas.Lineto (HalfAdjust(Width/2-Barwidth/2),HalfAdjust(BarTopY-5));
  Canvas.Lineto (HalfAdjust(Width/2),HalfAdjust(BarTopY-15));
  Canvas.Lineto (HalfAdjust(Width/2+BarWidth/2),HalfAdjust(BarTopY-5));
  Canvas.Lineto (HalfAdjust(Width/2+Barwidth/2),HalfAdjust((BarBottomY+ (FValue- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))));

  //
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Color:= FBarColor;
  canvas.Pen.Width:= WidthOutline;
  Canvas.Brush.color := FBarColor;
  canvas.Brush.Style:= bssolid;
  canvas.Ellipse(halfadjust(width/2   -SphereDiameter/2), halfadjust(SphereTopY), halfadjust(width/2   +SphereDiameter/2), halfadjust(SphereBottomY));

  //ڐ
  //PxƂ̐
  Canvas.Pen.Color:= clBlack;
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Width:=WidthScale1Degree;
  for i:=FValueMin to FValueMax do
  begin
    if FTypeScaleInterval= si01 then
    begin
      if (i mod 5<>0) then
      begin
        canvas.MoveTo(HalfAdjust(width/2-width/16),   HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
        canvas.lineTo(HalfAdjust(Width/2+width/16),   HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
      end;
    end;
  end;
  //QxƂ̐
  canvas.Pen.Width:=WidthScale1Degree;
  for i:=FValueMin to FValueMax do
  begin
    if FTypeScaleInterval= si02 then
    begin
      if ((i mod 2=0) and (i mod 10<>0)) then
      begin
        canvas.MoveTo(HalfAdjust(width/2-width/16),   HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
        canvas.lineTo(HalfAdjust(Width/2+width/16),   HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
      end;
    end;
  end;
  //TxƂ̐
  canvas.Pen.Width:=WidthScale5Degree;
  for i:=FValueMin to FValueMax do
  begin
    if (((i mod 5=0) and (i mod 10<>0)) and (FTypeScaleInterval= si05) or ((FTypeScaleInterval= si01) and (i mod 5=0)))then
    begin
      canvas.MoveTo(HalfAdjust(width/2-width/8),    HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
      canvas.lineTo(HalfAdjust(Width/2+width/8),    HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
      end;
  end;
  //POxƂ̐
  canvas.Pen.Width:=WidthScale10Degree;
  for i:=FValueMin to FValueMax do
  begin
    if (i mod 10=0) then
      begin
      canvas.MoveTo(HalfAdjust(width/2-width/6),    HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
      canvas.lineTo(HalfAdjust(Width/2+width/6),    HalfAdjust(BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY)));
    end;
  end;

  // e[x]
  canvas.Pen.Color:= clBlack;
  canvas.Pen.Style:= psSolid;
  Canvas.Brush.Style := bsclear;
  Canvas.Font.size:= FFontSizeDegree;
  Canvas.Font.Color := clWindowText;

  for i:=FValueMin to FValueMax do
  begin
    ValueText := inttostr(i);
    //̈ݒ肷iEj
    ValueTextRect := Rect(HalfAdjust(Width/2+width/6-FFontSizeDegree*4/3+15), HalfAdjust((BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))-FFontSizeDegree*2/3), HalfAdjust(Width/2+width/6+FFontSizeDegree*4/3+15), HalfAdjust((BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))+FFontSizeDegree*2/3));
    case FTypeCharacterDegree of
      cd20   :if ((i mod 20)=0) then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_Right);
      cd10   :if ((i mod 10)=0) then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_Right);
    end;
    //̈ݒ肷ij
    ValueTextRect := Rect(HalfAdjust(width/2-width/6-FFontSizeDegree*10/3+15), HalfAdjust((BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))-FFontSizeDegree*2/3), HalfAdjust(width/2-width/6-FFontSizeDegree*4/3+15), HalfAdjust((BarBottomY+ (i- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))+FFontSizeDegree*2/3));
    case FTypeCharacterDegree of
      cd20   :if ((i mod 20)=0) then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_Right);
      cd10   :if ((i mod 10)=0) then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_Right);
    end;
  end;

  // P[]
  if FTypeUnitKind= ukSign then ValueText := ''
                          else ValueText := 'x';
  //̈ݒ肷iEj
  ValueTextRect := Rect(HalfAdjust(Width/2+width/6-FFontSizeDegree*4/3+15), HalfAdjust(UnitTopY), HalfAdjust(Width/2+width/6+FFontSizeDegree*4/3+15), HalfAdjust(UnitBottomY));
  DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_Right);
  //̈ݒ肷ij
  ValueTextRect := Rect(HalfAdjust(Width/2-width/6-FFontSizeDegree*10/3+15), HalfAdjust(UnitTopY), HalfAdjust(Width/2-width/6-FFontSizeDegree*4/3+15), HalfAdjust(UnitBottomY));
  DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_Right);

  //_
  canvas.Pen.color:= FBoardColor;
  Canvas.Brush.style := bsSolid;
  Canvas.Brush.Color := FBoardColor;
  Canvas.RectAngle(HalfAdjust(Width/2-Barwidth/2+1), HalfAdjust(SphereBottomY-SphereDiameter/2), HalfAdjust(Width/2+BarWidth/2), HalfAdjust(BarTopY));

  canvas.Pen.Color:= FBarColor;
  Canvas.Pen.Width:= 1;
  Canvas.Brush.style := bsClear;
  Canvas.Brush.Color := FBarColor ;
  Canvas.RectAngle(HalfAdjust(Width/2-Barwidth/2), HalfAdjust(SphereBottomY-SphereDiameter/2), HalfAdjust(Width/2+BarWidth/2), HalfAdjust((BarBottomY+ (FValue- FValueMin)/(FValueMax-FValueMin)*(BarTopY -BarBottomY))));
end;

procedure TThermometer.Change;
// OnChangeCxg̃CxgfBXpb`
begin
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TThermometer.Resize;
//Rg[̃TCYύX
begin
  inherited;
  if width<>150 then width:=150;
  if height<500 then height:=500;
  FBarWidth:=HalfAdjust(Width /160*5);
  FFontSizeDegree:= HalfAdjust(Height /160*4);
  UnitTopY:=FMargin+10;
  UnitBottomY:=UnitTopY+HalfAdjust(FFontSizeDegree*1.5);
  SphereBottomY:=Height-FMargin-10;
  SphereTopY:=   SphereBottomY- SphereDiameter;
  BarBottomY:=  SphereTopY-20;
  BarTopY:=UnitBottomY+20;

  Invalidate;
  Change;
end;

procedure TThermometer.SetBarColor(const Value: TColor);
// _̐FύX
var
  NewBarColor: Integer;
begin
  NewBarColor := Value;
  if FBarColor <> NewBarColor then
  begin
    FBarColor := NewBarColor;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetBarWidth(const Value: byte);
// _̑ύX
var
  NewBarWidth: byte;
begin
  NewBarWidth:= Value;
  if NewBarWidth>10 then NewBarWidth:=10;
  if NewBarWidth<4 then NewBarWidth:=4;
  if BarWidth <> NewBarWidth then
  begin
    FBarWidth:= NewBarWidth;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetBoardColor(const Value: TColor);
// wiFύX
var
  NewBoardColor: Integer;
begin
  NewBoardColor := Value;
  if FBoardColor <> NewBoardColor then
  begin
    FBoardColor := NewBoardColor;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetFontSizeDegree(const Value: byte);
// Ղ̐l̃tHgTCYύX
var
  NewFontSizeDegree: byte;
begin
  NewFontSizeDegree := Value;
  if FFontSizeDegree <> NewFontSizeDegree then
  begin
    FFontSizeDegree := NewFontSizeDegree;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetMargin(const Value: byte);
// ㉺E̗]ύX
var
  NewMargin: byte;
begin
  NewMargin:= Value;
  if Margin <> NewMargin then
  begin
    FMargin:= NewMargin;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetTypeCharacterDegree(const Value: TTypeCharacterDegree);
//ڐl\̌^ύX
var
  NewTypeCharacterDegree: TTypeCharacterDegree;
begin
  NewTypeCharacterDegree:= value;
  if TypeCharacterDegree <> NewTypeCharacterDegree then
  begin
    FTypeCharacterDegree := Value;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetTypeScaleInterval(const Value: TTypeScaleInterval);
//ڐ\̌^ύX
var
  NewTypeScaleInterval: TTypeScaleInterval;
begin
  NewTypeScaleInterval:= value;
  if TypeScaleInterval <> NewTypeScaleInterval then
  begin
    FTypeScaleInterval := Value;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetTypeUnitKind(const Value: TTypeUnitKind);
//Pʂ̌^ύX
begin
  FTypeUnitKind := Value;
  Invalidate;
  Change;
end;

procedure TThermometer.SetValue(const Value: integer);
// xύX
var
  NewValue: integer;
begin
  NewValue := Value;
  // VlO̒lƈقȂȂʒuXVOnChangeCxgN
  if (FValue <> NewValue)  then
  begin
    if NewValue>FValueMax then NewValue:= FValueMax;
    if NewValue<FValueMin then NewValue:= FValueMin;

    FValue:= NewValue;

    Invalidate;
    Change;  // OnChangeCxg
  end;
end;

procedure TThermometer.SetWidthOutline(const Value: byte);
// O`̑ύX
var
  NewWidthOutline: byte;
begin
  NewWidthOutline:= Value;
  if WidthOutline <> NewWidthOutline then
  begin
    FWidthOutline:= NewWidthOutline;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetWidthScale1Degree(const Value: byte);
// Px݂̐̑ύX
var
  NewWidthScale1Degree: byte;
begin
  NewWidthScale1Degree:= Value;
  if WidthScale1Degree <> NewWidthScale1Degree then
  begin
    FWidthScale1Degree:= NewWidthScale1Degree;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetWidthScale5Degree(const Value: byte);
// Tx݂̐̑ύX
var
  NewWidthScale5Degree: byte;
begin
  NewWidthScale5Degree:= Value;
  if WidthScale5Degree <> NewWidthScale5Degree then
  begin
    FWidthScale5Degree:= NewWidthScale5Degree;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetWidthScale10Degree(const Value: byte);
// POx݂̍̐̑ύX
var
  NewWidthScale10Degree: byte;
begin
  NewWidthScale10Degree:= Value;
  if WidthScale10Degree <> NewWidthScale10Degree then
  begin
    FWidthScale10Degree:= NewWidthScale10Degree;

    Invalidate;
    Change;
  end;
end;

procedure TThermometer.SetValueMax(const Value: integer);
// ől[x]ύX
begin
  FValueMax := Value;
  if FValueMax>200 then FVAlue:=200;
  if FValueMax <= FValueMin then FValueMin := FValueMax-1;
  if FValue > FValueMax then FValue := FValueMax;
  Invalidate;
  change;
end;

procedure TThermometer.SetValueMin(const Value: integer);
// ől[x]ύX
begin
  FValueMin := Value;
  if FValueMin<-20 then FValueMin:=-20;
  if FValue < FValueMin then FValue := FValueMin;
  Invalidate;
  change;
end;

end.

